package SOFA.Component.DCUP;


/** Component builder. Concrete component builders implement this interface.
  * Generated by SOFA CodeGen.
  */

public interface ComponentBuilderOperations  {
        /** Initializing of the component builder. This method usually must be completed by the developer.
          * @param   cm    component manager
          * @param   dd    deployment descriptor
          * @exception  ComponentLifecycleException   builder cannot be initialized
          */
  void initialize(SOFA.Component.ComponentManager cm, SOFA.SOFAnode.Run.Deployment.DeploymentDescriptor dd) throws SOFA.Component.ComponentLifecycleException;
        /** Destroys component internals. This method is called by the component manager
          * at the time of the component terminating.
          * @param stateStore   storage for component state
          * @exception ComponentLifecycleException   component cannot be terminated
          */
  void onLeaving(SOFA.SOFAnode.Run.Storage stateStore) throws SOFA.Component.ComponentLifecycleException;
        /** Builds component internals. This method is called by the component manager
          * at the time of the component creating.
          * @param stateStore   storage for component state
          * @exception ComponentLifecycleException   component cannot be build
          */
  void onArrival(SOFA.SOFAnode.Run.Storage stateStore) throws SOFA.Component.ComponentLifecycleException;
        /** Stores component state - not implemented.
          * @param stateStore   storage for component state
          * @exception ComponentLifecycleException   component cannot be stored
          */
  void store(SOFA.SOFAnode.Run.Storage stateStore) throws SOFA.Component.ComponentLifecycleException;
        /** Restores component state - not implemented.
          * @param stateStore   storage for component state
          * @exception ComponentLifecycleException   component cannot be restored
          */
  void restore(SOFA.SOFAnode.Run.Storage stateStore) throws SOFA.Component.ComponentLifecycleException;
        /** Tests if this component can be updated.
          * @return   <tt>true</tt> if component can be updated
          */
  boolean isUpdatable();
        /** Tests if this component is stopped, i.e. all own threads was stopped and destroyed.
          * @return   <tt>true</tt> if component is stopped
          */
  boolean isStopped();
}
