/*
 * CDL2IDLMapping.java
 *
 * Created on 7. duben 2002, 10:23
 */

package SOFA.Connector.EEG.CodeWriter;

import SOFA.SOFAnode.Made.TIR.*;
import SOFA.SOFAnode.Made.TIR.Access.TIRAccessMethods;

/**
 *
 * @author  ghort
 * @version 
 */
public class CDL2IDLMapping {

	static protected SOFA.SOFAnode.Made.CodeGen.IDLMapping mapping;
	
	static public String getTypeName(CDLType cdlType) throws CodeWriterException {
		if (mapping==null) {
			mapping=new SOFA.SOFAnode.Made.CodeGen.IDLMapping();
		}
		String ret;

		ret=mapping.getImplTypeName(cdlType);

		if (ret==null) {
			throw new CodeWriterException("Cannot map CDL type to Java.");
		}
		return ret;
	}

	static public String getTypeDecl(CDLType cdlType, int paramMode) throws CodeWriterException {
		String ret;
		if (paramMode==ParamMode.PARAM_IN) {
			ret="in ";
		} else if (paramMode==ParamMode.PARAM_OUT) {
			ret="out ";
		} else if (paramMode==ParamMode.PARAM_INOUT) {
			ret="inout ";
		} else {
			throw new CodeWriterException("Invalid parameter mode.");
		}
			
		return ret + getTypeName(cdlType);
	}

}
