/*
 * Maker.java
 *
 * Created on 2. duben 2002, 13:42
 */

package SOFA.Connector.EEG.EEM;

import org.w3c.dom.*;

/**
 *
 * @author  ghort
 * @version 
 */
public class Maker implements SOFA.Connector.EEG.EEGPluginInterface {
	
	protected java.util.LinkedList action; /* of ActionInterface */
	protected java.util.LinkedList element; /* of ElementDescription */

  protected SOFA.SOFAnode.Run.CCNS.ConnectorCacheNS ccns;
	
	protected javax.xml.parsers.DocumentBuilderFactory documentBuilderFactory;
	protected javax.xml.parsers.DocumentBuilder documentBuilder;
	
	protected Document configDoc;
	
	protected java.util.HashMap props;

	protected String elementsPath;
	protected String elementsPackage;
	
	protected String builtDir;
	protected String builtPackage;

	protected String translateMangledPath(String mangled) throws java.rmi.RemoteException {
		StringBuffer buf=new StringBuffer();
		int i, len=mangled.length();
		char a;

		buf.append("EEM__");

		for (i=0;i<len;i++) {
			a=mangled.charAt(i);
			if (a=='_') {
				buf.append("__");
			} else if (a==':') {
				if (i+1<len && mangled.charAt(i+1)==':') {
					i++;
					buf.append("_CC_");
				} else {
					buf.append("_C_");
				}
			} else if (a=='/') {
				buf.append("_S_");
			} else if (a=='.') {
				buf.append("_D_");
			} else if (a=='?') {
				buf.append("_Q_");
			} else if (a=='!') {
				buf.append("_E_");
			} else if (Character.isJavaIdentifierPart(a)) {
				buf.append(a);
			} else {
				buf.append("_"+Integer.toString(a,16)+"_");
			}
		}
		return ccns.getHashByName(buf.toString());
	}
	
	/** Creates new Maker */
	public Maker(java.util.HashMap props) throws SOFA.Connector.EEG.EEGPluginException {
		this.props=props; 
		 
		try {
			documentBuilderFactory=javax.xml.parsers.DocumentBuilderFactory.newInstance();
			documentBuilder=documentBuilderFactory.newDocumentBuilder();
		
			String confFile=(String)props.get("configuration");
			if (confFile==null) {
				confFile="EEM/conf.xml";
			}
			confFile=SOFA.Connector.EEG.EEGenerator.getEEGConfigRoot()+"/"+confFile;
			configDoc=documentBuilder.parse(new java.io.File(confFile));
			
			Element elParent=configDoc.getDocumentElement();
			Node elL1, elL2, elL3;
			
			action=new java.util.LinkedList();
			element=new java.util.LinkedList();
			
			System.out.println("    Loading Maker actions & elements:");
			elL1=elParent.getFirstChild();
			while (elL1!=null) {
				if (elL1.getNodeType()==Node.ELEMENT_NODE && elL1.getNodeName().equals("elementsPath")) {
					elL2=elL1.getFirstChild();
					while (elL2!=null) {
						if (elL2.getNodeType()==Node.TEXT_NODE) {
							elementsPath=SOFA.Connector.EEG.EEGenerator.getEEGRoot()+"/EEM/"+elL2.getNodeValue();
							break;
						}
						elL2=elL2.getNextSibling();
					}
				} else if (elL1.getNodeType()==Node.ELEMENT_NODE && elL1.getNodeName().equals("elementsPackage")) {
					elL2=elL1.getFirstChild();
					while (elL2!=null) {
						if (elL2.getNodeType()==Node.TEXT_NODE) {
							elementsPackage=elL2.getNodeValue();
							break;
						}
						elL2=elL2.getNextSibling();
					}
				} else if (elL1.getNodeType()==Node.ELEMENT_NODE && elL1.getNodeName().equals("builtDir")) {
					elL2=elL1.getFirstChild();
					while (elL2!=null) {
						if (elL2.getNodeType()==Node.TEXT_NODE) {
							builtDir=SOFA.Connector.EEG.EEGenerator.getEEGRoot()+"/EEM/"+elL2.getNodeValue();
							break;
						}
						elL2=elL2.getNextSibling();
					}
				} else if (elL1.getNodeType()==Node.ELEMENT_NODE && elL1.getNodeName().equals("builtPackage")) {
					elL2=elL1.getFirstChild();
					while (elL2!=null) {
						if (elL2.getNodeType()==Node.TEXT_NODE) {
							builtPackage=elL2.getNodeValue();
							break;
						}
						elL2=elL2.getNextSibling();
					}
				} else if (elL1.getNodeType()==Node.ELEMENT_NODE && elL1.getNodeName().equals("EEMActions")) {
					elL2=elL1.getFirstChild();
					while (elL2!=null) {
						if (elL2.getNodeType()==Node.ELEMENT_NODE && elL2.getNodeName().equals("EEMAction")) {
							
							java.util.HashMap plProps=new java.util.HashMap();
							elL3=elL2.getFirstChild();
							while (elL3!=null) {
								if (elL3.getNodeType()==Node.ELEMENT_NODE) {
									Element el=(Element)elL3;
									if (el.getTagName().equals("property") && el.hasAttribute("name") && el.hasAttribute("value")) {
										plProps.put(el.getAttribute("name"),el.getAttribute("value"));
									}
								}
								elL3=elL3.getNextSibling();
							}
							
							try {
								System.out.print("      Action ("+((Element)elL2).getAttribute("class")+") ");
								Class cls=Class.forName(((Element)elL2).getAttribute("class"));
								Class[] coPar=new Class[1];
								coPar[0]=Class.forName("java.util.HashMap");
								java.lang.reflect.Constructor co=cls.getConstructor(coPar);
							
								Object[] coInst=new Object[1];
								coInst[0]=plProps;
								ActionInterface plgObject=(ActionInterface)co.newInstance(coInst);
							
								action.add(plgObject);
							} catch (Exception excpt) {
								System.out.println(" ... loading failed");
								throw excpt;
							}

							System.out.println("loaded");
						}
						elL2=elL2.getNextSibling();
					}
				} else if (elL1.getNodeType()==Node.ELEMENT_NODE && elL1.getNodeName().equals("EEMElements")) {
					elL2=elL1.getFirstChild();
					while (elL2!=null) {
						if (elL2.getNodeType()==Node.ELEMENT_NODE && elL2.getNodeName().equals("EEMElement")) {
							ElementDescription elDescr=ElementDescription.fromXMLFile(elementsPath+"/"+((Element)elL2).getAttribute("file"));
							element.add(elDescr);
							System.out.println("      Element description "+elDescr.name+" ("+((Element)elL2).getAttribute("file")+") loaded");
						}
						elL2=elL2.getNextSibling();
					}
				}
				elL1=elL1.getNextSibling();
			}

			builtDir=System.getProperty("SOFA.Connector.EEG.EEM.BuiltDir",builtDir);
			builtPackage=System.getProperty("SOFA.Connector.EEG.EEM.BuiltPackage",builtPackage);
						
			System.out.println("    Connecting to Connector Cache Name Server.");
      ccns=SOFA.Connector.CCNSAccess.CCNSAccess.openCCNS();
      
		} catch (Exception e) {
			throw new SOFA.Connector.EEG.EEGPluginException("Can't parse configuration",e);
		}
	}

	public String getName() {
		return "EEM";
	}
	 
	public SOFA.Connector.EEG.ElementTechnologyDescriptor[] canGenerate(SOFA.Connector.EEG.ElementQuery query) {
		java.util.Iterator iter;
		java.util.LinkedList techDesc=new java.util.LinkedList();

		for (iter=element.iterator();;) {
			ElementDescription ed;
			try {
				ed=(ElementDescription)iter.next();
			} catch (java.util.NoSuchElementException e) {
				break;
			}
			if (query.type.equals(ed.type)) {
				boolean isSuitable=true;
				int i, j;
				for (i=0;i<ed.conditions.length && isSuitable;i++) {
					for (j=0;j<query.props.length;j++) {
						if (query.props[j].name.equals(ed.conditions[i].name) && query.props[j].value.equals(ed.conditions[i].value)) {
							break;
						}
					}
					if (j==query.props.length) {
						isSuitable=false;
					}
				}

				if (isSuitable) {
					SOFA.Connector.EEG.ElementTechnologyDescriptor tDesc=new SOFA.Connector.EEG.ElementTechnologyDescriptor();
					tDesc.name=ed.name;
					tDesc.implementation=getName()+":"+ed.name;
					techDesc.add(tDesc);
				}
			}
		}

		SOFA.Connector.EEG.ElementTechnologyDescriptor[] ret=new SOFA.Connector.EEG.ElementTechnologyDescriptor[techDesc.size()];
		iter=techDesc.iterator();
		for (int i=0;;i++) {
			try {
				ret[i]=(SOFA.Connector.EEG.ElementTechnologyDescriptor)iter.next();
			} catch (java.util.NoSuchElementException e) {
				break;
			}
		}
		
		return ret;
	}
	
	public SOFA.Connector.EEG.ElementOutputDescriptor generate(SOFA.Connector.EEG.ElementInputDescriptor elDescr) throws SOFA.Connector.EEG.EEGPluginException {
		java.util.Iterator iter;
		ElementDescription ed;
		String impl;
		int i;

		i=elDescr.implementation.indexOf(':');
		try {
			if (i==-1 || !elDescr.implementation.substring(0,i).equals(getName())) {
				throw new SOFA.Connector.EEG.EEGPluginException("Malformed implementation specification.");
			}
			impl=elDescr.implementation.substring(i+1);
		} catch (Exception e) {
			throw new SOFA.Connector.EEG.EEGPluginException("Malformed implementation specification.");
		}
	
		iter=element.iterator();
		while (iter.hasNext()) {
			ed=(ElementDescription)iter.next();
			if (ed.name.equals(impl)) {
				java.util.Iterator it, it2;
				
				SOFA.Connector.ECG.VariableExpander expander=new SOFA.Connector.ECG.VariableExpander();
				for (i=0;i<elDescr.props.length;i++) {
					try {
						expander.addSubst(elDescr.props[i].name,elDescr.props[i].value);
					} catch (SOFA.Connector.ECG.VariableExpanderAmbiguityException e) {
					}
				}

				String mangledDirName;
				String mangledPackageName;
				try {
					String mangledPath=translateMangledPath(expander.expand(ed.mangled));
					mangledDirName=builtDir+"/"+mangledPath;
					mangledPackageName=builtPackage+"."+mangledPath;
				} catch (SOFA.Connector.ECG.VariableExpanderException e) {
					throw new SOFA.Connector.EEG.EEGPluginException("Can't resolve variable '"+ed.mangled+"'.",e);
				} catch (java.rmi.RemoteException e) {
          throw new SOFA.Connector.EEG.EEGPluginException("Can't use CCNS to translate element name.",e);
        }

				java.io.File mangledDir=new java.io.File(mangledDirName);

				if (!mangledDir.isDirectory())
				{
					if (!mangledDir.mkdirs()) {
						throw new SOFA.Connector.EEG.EEGPluginException("Can't create built dir '"+mangledDirName+"'.");
					}

					try {
						ActionInterface act;
						it=ed.make.iterator();
						while (it.hasNext()) {
							Object cmdOrBld=it.next();

							if (cmdOrBld instanceof ElementDescriptionCommand) {
								ElementDescriptionCommand cmd=(ElementDescriptionCommand)cmdOrBld;
							
								try {
									for (it2=action.iterator();;) {
										act=(ActionInterface)it2.next();
										if (act.getName().equals(cmd.action)) {
											break;
										}
									}
								} catch (java.util.NoSuchElementException e) {
									throw new SOFA.Connector.EEG.EEGPluginException("Can't find action '"+cmd.action+"'.",e);
								}

								System.out.print("    Performing action '"+cmd.action+"' ... ");
								
								try {
									SOFA.Connector.Property[] actParams=new SOFA.Connector.Property[cmd.params.length];
									for (i=0;i<cmd.params.length;i++) {
										try {
											actParams[i]=new SOFA.Connector.Property(cmd.params[i].name,expander.expand(cmd.params[i].value));
										} catch (SOFA.Connector.ECG.VariableExpanderException e) {
											throw new SOFA.Connector.EEG.EEGPluginException("Can't resolve variable '"+cmd.params[i].name+"'.",e);
										}
									}

									try {
										act.perform(actParams,elementsPath,elementsPackage,mangledDirName,mangledPackageName);
									} catch (ActionException e) {
										throw new SOFA.Connector.EEG.EEGPluginException("Can't perform action '"+cmd.action+"' on element '"+elDescr.implementation+"'.",e);
									} 
								} catch (SOFA.Connector.EEG.EEGPluginException excpt) {
									System.out.println("failed");
									throw excpt;
								}

								System.out.println("OK");
							} else {
								ElementDescriptionBuild bld=(ElementDescriptionBuild)cmdOrBld;
							
								System.out.println("    Performing build for '"+bld.element+"':");

								SOFA.Connector.EEG.ElementInputDescriptor iDes=new SOFA.Connector.EEG.ElementInputDescriptor();
								iDes.instanceName=elDescr.instanceName;
								iDes.implementation=getName()+":"+bld.element;
								iDes.techProps=elDescr.techProps;

								SOFA.Connector.Property[] bldProps=new SOFA.Connector.Property[bld.props.length];
								for (i=0;i<bld.props.length;i++) {
									try {
										bldProps[i]=new SOFA.Connector.Property(bld.props[i].name,expander.expand(bld.props[i].value));
									} catch (SOFA.Connector.ECG.VariableExpanderException e) {
										throw new SOFA.Connector.EEG.EEGPluginException("Can't resolve variable '"+bld.props[i].name+"'.",e);
									}
								}
								iDes.props=bldProps;
								
								try {
									SOFA.Connector.EEG.ElementOutputDescriptor oDes=generate(iDes);

									String genPackage=oDes.impl.substring(0,oDes.impl.lastIndexOf('.'));
									String genPath=genPackage.replace('.','/');
									expander.addSubst(bld.packageVar,genPackage);
									expander.addSubst(bld.pathVar,genPath);
								} catch (Exception excpt) {
									throw new SOFA.Connector.EEG.EEGPluginException("Can't build '"+bld.element+"'.",excpt);
								}
								
								System.out.println("    Build '"+bld.element+"' successful.");
							}
						}
					} catch (SOFA.Connector.EEG.EEGPluginException e) {
// FIXME: in						try {
//							SOFA.Connector.EEG.fileutil.Delete.delete(mangledDir);
//							mangledDir.delete();
//						} catch (SOFA.Connector.EEG.fileutil.DeleteException excpt) {
//						}
						throw e;
					}
				}
				
				SOFA.Connector.EEG.ElementOutputDescriptor outDescr=new SOFA.Connector.EEG.ElementOutputDescriptor();
				outDescr.name=elDescr.instanceName;
				outDescr.impl=mangledPackageName+"."+ed.name;
				outDescr.params=new SOFA.Connector.Property[0]; // FIXME: najit zpusob, jak naplnit parametry

				return outDescr;
			}
		}
		throw new SOFA.Connector.EEG.EEGPluginException("Implementation '"+elDescr.implementation+"' not found.");
	}

}
