/* $Id: CompExprProperty.java,v 1.1.1.1 2003/02/11 16:19:40 bures Exp $ */
package SOFA.SOFAnode.Made.CDL; 
import SOFA.SOFAnode.Made.TIR.*;
import java.rmi.RemoteException;

class CompExprProperty extends CompExprOper {
  public String name;
  
  public CompExprProperty(String name) {
    super(CompExprKind.e_property);
    this.name = name;
  }

  public int type() { return CompExprKind.e_all; }
  public boolean isProp() { return true; }

  public EnumList nameProp(CompRepository rep) throws CDLExceptRemote, CDLExceptLock {
    EnumList l = new EnumList();
    l.addName(name);
    return l;
  }
  
  public int isPositive() {
    return -1;
  }

  public ExprOperDef toNormal(CDLRepository rep) throws CDLExceptToNormal, CDLExceptRemote, CDLExceptLock {
    try {
      return ((Repository) rep.get_containing_repository()).create_exprproperty(name);
    } catch (RemoteException e) {
      throw new CDLExceptRemote("Remote exception occured: "+e.getMessage());
    } catch (TIRExceptCreate ecr) {
      throw new CDLExceptToNormal("Can't create expression");
    }
  }

  public String toString() {
    return "$"+name;
  }
}
