/* $Id: CompExprUnOper.java,v 1.1.1.1 2003/02/11 16:19:40 bures Exp $ */
package SOFA.SOFAnode.Made.CDL;
import SOFA.SOFAnode.Made.TIR.*;
import java.rmi.RemoteException;

class CompExprUnOper extends CompExprOper {
  public CompExprOper operand;
  public CompExprUnOper(int type, CompExprOper op) {
    super(type);
    operand = op;
  }

  public int type() { return operand.type(); }
  public boolean isProp() { return operand.isProp(); }

  public EnumList nameProp(CompRepository rep) throws CDLExceptRemote, CDLExceptLock {
    return operand.nameProp(rep);
  }

  public ExprOperDef toNormal(CDLRepository rep) throws CDLExceptToNormal, CDLExceptRemote, CDLExceptLock {
    try {
      return ((Repository) rep.get_containing_repository()).create_exprunoperation(kind, operand.toNormal(rep));
    } catch (RemoteException e) {
      throw new CDLExceptRemote("Remote exception occured: "+e.getMessage());
    } catch (TIRExceptCreate ecr) {
      throw new CDLExceptToNormal("Can't create expression");
    }
  }

  public String toString() {
    StringBuffer sb = new StringBuffer("(");
    switch (kind) {
    case CompExprKind.e_unminus:
      sb.append("-");
      break;
    case CompExprKind.e_unplus:
      sb.append("+");
      break;
    case CompExprKind.e_untilde:
      sb.append("~");
      break;
    }
    sb.append(operand.toString());
    sb.append(")");
    return sb.toString();
  }
}
