/* $Id: DetectedConnector.java,v 1.1.1.1 2003/02/11 16:19:40 bures Exp $ */
package SOFA.SOFAnode.Made.CDL;
import SOFA.SOFAnode.Made.TIR.*;
import java.rmi.RemoteException;


public class DetectedConnector {
  public java.util.ArrayList cRoles;   // list of CompBindOper
  public java.util.ArrayList sRoles;
  public String[] operations;
  public int bindMode;

  public String using;

  public DetectedConnector(CompBindOper cR, CompBindOper sR, int bindMode, String using) {
    this.using=using;
    cRoles = new java.util.ArrayList();
    sRoles = new java.util.ArrayList();
    cRoles.add(cR);
    sRoles.add(sR);
    this.bindMode = bindMode;
  }

  private boolean isBothZeroOrIsBothNonZero(int a, int b) {
    if (a==0 && b==0)
      return true;
    if (a!=0 && b!=0)
      return true;
    return false;
  }

  public boolean containsSameSRole(CompBindOper sR) {
    for (int i=0;i<sRoles.size();i++) {
      CompBindOper sRole = (CompBindOper) sRoles.get(i);
      if (sRole.kind == sR.kind) {
        CompBindType t1, t2;
        /* FIXME, where is delegation? */
        if (sRole.kind == CompBindOper.b_sub) {
          sRole.subs.toFirst(); sR.subs.toFirst();
          t1 = (CompBindType) sRole.subs.aktual();
          t2 = (CompBindType) sR.subs.aktual();
          if (t1.name.compareTo(t2.name)!=0) {
            continue;
          }
          if (!isBothZeroOrIsBothNonZero(t1.exprs.size(), t2.exprs.size())) {
            continue;
          }
        }
        /* FIXME, possibly bad, this should be 'else' branch */
        sRole.elements.toFirst(); sR.elements.toFirst();
        t1 = (CompBindType) sRole.elements.aktual();
        t2 = (CompBindType) sR.elements.aktual();
        if (t1.name.compareTo(t2.name)!=0) {
          continue;
        }
        if (!isBothZeroOrIsBothNonZero(t1.exprs.size(), t2.exprs.size())) {
          continue;
        }
        return true;
      } else {
        continue;
      }
    } // ---- end of for
    return false;
  }

  public boolean containsSameCRole(CompBindOper cR) {
    for (int i=0;i<cRoles.size();i++) {
      CompBindOper cRole = (CompBindOper) cRoles.get(i);
      if (cRole.kind == cR.kind) {
        CompBindType t1, t2;
        /* FIXME, where is delegation? */
        if (cRole.kind == CompBindOper.b_sub) {
          cRole.subs.toFirst(); cR.subs.toFirst();
          t1 = (CompBindType) cRole.subs.aktual();
          t2 = (CompBindType) cR.subs.aktual();
          if (t1.name.compareTo(t2.name)!=0) {
            continue;
          }
          if (!isBothZeroOrIsBothNonZero(t1.exprs.size(), t2.exprs.size())) {
            continue;
          }
        }
        /* FIXME, possibly bad, this should be 'else' branch */
        cRole.elements.toFirst(); cR.elements.toFirst();
        t1 = (CompBindType) cRole.elements.aktual();
        t2 = (CompBindType) cR.elements.aktual();
        if (t1.name.compareTo(t2.name)!=0) {
          continue;
        }
        if (!isBothZeroOrIsBothNonZero(t1.exprs.size(), t2.exprs.size())) {
          continue;
        }
        return true;
      } else {
        continue;
      }
    } // ---- end of for
    return false;
  }

  public int indexOfSRole(CompBindOper sR) {
    for (int i=0;i<sRoles.size();i++) {
      CompBindOper sRole = (CompBindOper) sRoles.get(i);
      if (sRole.kind == sR.kind) {
        CompBindType t1, t2;
        if (sRole.kind == CompBindOper.b_sub) {
          sRole.subs.toFirst(); sR.subs.toFirst();
          t1 = (CompBindType) sRole.subs.aktual();
          t2 = (CompBindType) sR.subs.aktual();
          if (t1.name.compareTo(t2.name)!=0)
            continue;
          if (!isBothZeroOrIsBothNonZero(t1.exprs.size(), t2.exprs.size()))
            continue;
        }
        sRole.elements.toFirst(); sR.elements.toFirst();
        t1 = (CompBindType) sRole.elements.aktual();
        t2 = (CompBindType) sR.elements.aktual();
        if (t1.name.compareTo(t2.name)!=0)
          continue;
        if (!isBothZeroOrIsBothNonZero(t1.exprs.size(), t2.exprs.size()))
          continue;
        return i;
      } else {
        continue;
      }
    } // ---- end of for
    return -1;
  }

  public int indexOfCRole(CompBindOper cR) {
    for (int i=0;i<cRoles.size();i++) {
      CompBindOper cRole = (CompBindOper) cRoles.get(i);
      if (cRole.kind == cR.kind) {
        CompBindType t1, t2;
        if (cRole.kind == CompBindOper.b_sub) {
          cRole.subs.toFirst(); cR.subs.toFirst();
          t1 = (CompBindType) cRole.subs.aktual();
          t2 = (CompBindType) cR.subs.aktual();
          if (t1.name.compareTo(t2.name)!=0)
            continue;
          if (!isBothZeroOrIsBothNonZero(t1.exprs.size(), t2.exprs.size()))
            continue;
        }
        cRole.elements.toFirst(); cR.elements.toFirst();
        t1 = (CompBindType) cRole.elements.aktual();
        t2 = (CompBindType) cR.elements.aktual();
        if (t1.name.compareTo(t2.name)!=0)
          continue;
        if (!isBothZeroOrIsBothNonZero(t1.exprs.size(), t2.exprs.size()))
          continue;
        return i;
      } else {
        continue;
      }
    } // ---- end of for
    return -1;
  }

  public void addSRole(CompBindOper sR) {
    sRoles.add(sR);
  }
  
  public void addCRole(CompBindOper cR) {
    cRoles.add(cR);
  }
}
