/* $Id: CDLContainer.java,v 1.1.1.1 2003/02/11 16:19:41 bures Exp $ */
package SOFA.SOFAnode.Made.TIR;
import java.rmi.RemoteException;

/** <i>Container</i> interface for the conatiner objects from the CDL. */
public interface CDLContainer extends Container {
  /** Creates module in this container. */
  public ModuleDef    create_module(Identification id) throws RemoteException, TIRExceptCreate, TIRExceptLock;
  /** Creates constant in this container. */
  public ConstantDef  create_constant(Identification id, CDLType type, ExprOperDef value) throws RemoteException, TIRExceptCreate, TIRExceptLock;
  /** Creates struct in this container. */
  public StructDef    create_struct(Identification id) throws RemoteException, TIRExceptCreate, TIRExceptLock;
  /** Creates union in this container. */
  public UnionDef     create_union(Identification id, CDLType switch_type) throws RemoteException, TIRExceptCreate, TIRExceptLock;
  /** Creates enum in this container. */
  public EnumDef      create_enum(Identification id) throws RemoteException, TIRExceptCreate, TIRExceptLock;
  /** Creates typedef in this container. */
  public TypedefDef   create_typedef(Identification id, CDLType orig_type) throws RemoteException, TIRExceptCreate, TIRExceptLock;
  /** Creates exception in this container. */
  public ExceptionDef create_exception(Identification id) throws RemoteException, TIRExceptCreate, TIRExceptLock;
  /** Creates interface in this container. */
  public InterfaceDef create_interface(Identification id, InterfaceDef[] base_interfaces) throws RemoteException, TIRExceptCreate, TIRExceptLock;
  /** Creates interface in this container without specified base intefaces (it will be add later by Interface::setBaseInterface() method. */
  public InterfaceDef create_interface(Identification id) throws RemoteException, TIRExceptCreate, TIRExceptLock;
  /** Creates frame in this container. */
  public FrameDef     create_frame(Identification id, boolean system) throws RemoteException, TIRExceptCreate, TIRExceptLock;
}
