/* $Id: ExprUnsigLongImpl.java,v 1.1.1.1 2003/02/11 16:19:41 bures Exp $ */
package SOFA.SOFAnode.Made.TIR.Impl;
import SOFA.SOFAnode.Made.TIR.*;
import java.rmi.Remote;
import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;
import java.io.IOException;

public class ExprUnsigLongImpl extends UnicastRemoteObject implements ExprUnsigLong, TIRImplObject {
  int v;
  ExprOperKindImpl eok;
  DefinitionKindImpl defKindImpl;
  StateKindImpl stKindImpl; 

  public ExprUnsigLongImpl(int value) throws RemoteException {
    v = value;
    eok = new ExprOperKindImpl(ExprOperKind.eok_unsiglong);
    defKindImpl = new DefinitionKindImpl(DefinitionKind.dk_Expression);
    stKindImpl = new StateKindImpl(StateKind.sk_work);
  }

  public ExprUnsigLongImpl()  throws RemoteException {
    v = 0;
    eok = new ExprOperKindImpl(ExprOperKind.eok_unsiglong);
    defKindImpl = new DefinitionKindImpl(DefinitionKind.dk_Expression);
    stKindImpl = new StateKindImpl(StateKind.sk_normal);
  }

  /* from interface TIRObject */
  public DefinitionKind get_def_kind() throws RemoteException {
    return (DefinitionKind) defKindImpl;
  }

  /* from interface TIRObject */
  public StateKind get_state() throws RemoteException {
    return (StateKind) stKindImpl;
  }
  
  public int value() throws RemoteException {
    return v;
  }

  public void value(int value) {
    v = value;
  }

  public ExprOperKind get_eok_kind() throws RemoteException {
    return (ExprOperKind) eok;
  }
  
  public ExprOperDef calculate() throws RemoteException {
    return this;  /* !!! ? */
  }

  public void save(Storage st) throws RemoteException, TIRExceptStorage {
    try {
      st.curOutFile.writeInt(eok.value());
      st.curOutFile.writeInt(v);
    } catch (IOException e) {
      throw new TIRExceptStorage("Can't write in directory "+st.current+".");
    }
  }
  
  public void load(Storage st) throws RemoteException, TIRExceptStorage {
    try {
      v = st.curInFile.readInt();   
    } catch (IOException e) {
      throw new TIRExceptStorage("Can't read in directory "+st.current+".");
    }
  }

  public void postLoad(RepositoryImpl r) throws RemoteException, TIRExceptStorage {
    ;
  }

  public boolean isNew() {
    return (stKindImpl.value()==StateKind.sk_work);
  }

  public void canCommit() throws RemoteException, TIRExceptCommit {;}

  public void doCommit(Container in, Repository rep) throws RemoteException {
    if (stKindImpl.value()==StateKind.sk_work)
      stKindImpl.toNormal();
  }

  public void doAbort(long workId) throws RemoteException {}
}
