/* $Id: Main.java,v 1.1.1.1 2003/02/11 16:19:41 bures Exp $ */
package SOFA.SOFAnode.Made.TIR.Impl;
import SOFA.SOFAnode.Made.TIR.*;
import java.rmi.Remote;
import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;
import java.rmi.RMISecurityManager;
import java.rmi.Naming;
import java.net.InetAddress;
import java.net.UnknownHostException;

public class Main {
  
  /* set path to repository storage in first argument (argv[0]) */
  public static void main(String[] argv) {
    // Create and install a security manager
    if (System.getSecurityManager() == null) {
      System.setSecurityManager(new RMISecurityManager());
    }
        
    try {
      if (argv.length==0) {
        System.err.println("Set directory with repository to the first argument.");
        System.exit(1);
      }
      String rmiport = System.getProperty("sofa.rmiport","1099");
      String rmihost = System.getProperty("sofa.rmihost","localhost");
      String sofaNodeName = System.getProperty("sofa.nodename","");
      
      if (sofaNodeName.compareTo("")==0) {
        try {
          sofaNodeName = InetAddress.getLocalHost().getHostName();
        } catch (UnknownHostException e) { 
          System.err.println("Can't get host name. Set name to property \"sofa.nodename\"");
          System.exit(1);
        }
      }

      System.setProperty("sofa.nodename",sofaNodeName);
      
      RepositoryImpl repository = new RepositoryImpl(argv[0],sofaNodeName);
      Naming.rebind("//"+rmihost+":"+rmiport+"/Repository", repository);
      
      System.out.println("Repository bound in registry");
    } catch (Exception e) {
      System.out.println("Exception " + e.getMessage());
      e.printStackTrace();
    }
  }
  
}
