/* $Id: UnionDef.java,v 1.1.1.1 2003/02/11 16:19:41 bures Exp $ */
package SOFA.SOFAnode.Made.TIR;
import java.rmi.RemoteException;

/** Interface for the union */
public interface UnionDef extends Contained, Container, CDLType {
  /** Switch type of this union */
  public CDLType switch_type() throws RemoteException;
  /** members of this union */
  public UnionMember[] members() throws RemoteException, TIRExceptLock;  
  /** Create new member in this union */
  public UnionMember create_member(String name, CDLType type, ExprOperDef[] label) throws RemoteException, TIRExceptCreate, TIRExceptLock;
  /** Create new struct in this union */
  public StructDef create_struct(Identification id) throws RemoteException, TIRExceptCreate, TIRExceptLock;
  /** Create new union in this union */
  public UnionDef create_union(Identification id, CDLType switch_type) throws RemoteException, TIRExceptCreate, TIRExceptLock;
  /** Create new enum in this union */
  public EnumDef create_enum(Identification id) throws RemoteException, TIRExceptCreate, TIRExceptLock;
}
