/* $Id: ProtocolOrParallel.java,v 1.1.1.1 2003/02/11 16:19:41 bures Exp $ */

package SOFA.SOFAnode.Util;

import java.util.*;

class ProtocolOrParallel extends ProtocolBinaryOperator {

    public ProtocolOrParallel( Protocol l, Protocol r ) {
	super( "||",l,r );
    }
    
    public Protocol Copy() {
	return new ProtocolOrParallel( left.Copy(), right.Copy() );
    }
    
    public Machine createMachine() {

        int i,j,n1,n2,t,e;
	
        machineImpl m1 = (machineImpl)left.createMachine();
	machineImpl m2 = (machineImpl)right.createMachine();

              Debug.println(2,"This is createOrParallel of ");
	Debug.println(2,"Machine left:");
	((Printer)m1).Print(2);
	Debug.println(2,"Machine right:");
	((Printer)m2).Print(2);

	int mapping [][] = new int[m1.nextID][m2.nextID];
        machineImpl m = new machineImpl( m1.nextID * m2.nextID);

        for( i = 0; i < m1.nextID; i++ )
	    for( j = 0; j < m2.nextID; j++ ) mapping[i][j] = m.addState();

	if( Debug.debug>1 ) {
        Debug.println(2, "Mapping:" );
        for( i = 0; i < m1.nextID; i++ )
	    for( j = 0; j < m2.nextID; j++ ) 
                Debug.println(2, "[" + i + "," + j + "] -> " + mapping[i][j]);
	}

	Debug.println(3, "Adding edges:");

	for( n1 = 0 ; n1< m1.nextID ; n1++ ) 
	    for( n2 = 0; n2 < m2.nextID; n2++ ) {
		Debug.println(3, "Adding edges to ["+n1+","+n2+"]");
		for( t = 0 ; t < EdgeFactory.getActionTokensNum(); t ++ ){
		    if( m1.states[n1][t] != null )
			for( e = 0 ; e < m1.states[n1][t].used ; e++ )
			     m.addEdge( mapping[n1][n2],t,mapping[ m1.states[n1][t].data[e]][n2] );
		   
		    if( m2.states[n2][t] != null )
			for( e = 0 ; e < m2.states[n2][t].used ; e++ )
			     m.addEdge( mapping[n1][n2],t,mapping[n1][m2.states[n2][t].data[e]] );
		}
	    }

	Debug.println(3, "OrParallel: setting start");

	m.SetStart( mapping[m1.Start()][m2.Start()]);

	Debug.println(3, "OrParallel: states created");

	int n1i;
	Iterator l;

        Iterator k = m1.Stop().values().iterator();
        while( k.hasNext() ) {
            n1i = ((Integer)k.next()).intValue();
	    m.AddStop( mapping[n1i][ m2.Start() ] );
	    l = m2.Stop().values().iterator();
	    while( l.hasNext() ) m.AddStop(mapping[n1i][((Integer)l.next()).intValue()]);
        }

         k = m2.Stop().values().iterator();
        while( k.hasNext() ) {
            n1i = ((Integer)k.next()).intValue();
                m.AddStop(mapping[m1.Start()][n1i]);
        }

        k = m1.Update().values().iterator();
        while( k.hasNext() ) {
            n1i = ((Integer)k.next()).intValue();
	    l = m2.Update().values().iterator();
	    while( l.hasNext() ) m.addUpdateEdge(mapping[n1i][((Integer)l.next()).intValue()]);
        }

	m.Minimize();

        Debug.println(2,"createOrParallel: done - states:" + m.nextID);
	((Printer)m).Print(2);

        return m;
    }

    public Protocol getSameType( Object p1, Object p2 ) {
	return new ProtocolOrParallel( (Protocol)p1, (Protocol)p2 );
    }
}

